/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#include <cmath> // Функции вычисления синуса и косинуса
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component ("Central Component")
{
    setSize (100, 100);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    // Фон виджета - белый
    Canvas.fillAll(Colours::white);
    
    // Цвет рисуемых линий - чёрный
    Canvas.setColour(Colours::black);
    
    int iPointsNumber = 8;
    // Массивы для хранения координат точек, 
    // через которые будут проходить линии
    Array<float> fXs;
    Array<float> fYs;
    // Вычисляем координаты точек
    for(int i = 0; i < iPointsNumber; ++i)
    {
        float fAngle = 2 * float_Pi * i / iPointsNumber;
        int iX = 50 + cos(fAngle) * 40;
        int iY = 50 + sin(fAngle) * 40;
        // и сохраняем их в массивах
        fXs.add((float)iX);
        fYs.add((float)iY);
    }

    // Отрезок линии - 8 пикселей,
    // пробел - 4 пикселя
    float fDashLengths[] = {8, 4};
    for(int i = 0; i < iPointsNumber; ++i)
    {
        if(i != 7)
        {
            // Рисуем линию толщиной 3 пикселя
            Canvas.drawDashedLine(Line<float>(fXs[i], fYs[i], fXs[i + 1], fYs[i + 1]), fDashLengths, 2, 3.0f);
        }
        else
        {
            // Завершаем многоугольник
            Canvas.drawDashedLine(Line<float>(fXs[7], fYs[7], fXs[0], fYs[0]), fDashLengths, 2, 3.0f);
        }
    }
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
}
//---------------------------------------------------------------------

