/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#include <cmath> // Функции вычисления синуса и косинуса
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component ("Central Component")
{
    setSize(100, 100);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    // Фон виджета - белый
    Canvas.fillAll(Colours::white);
    
    // Цвет рисуемых точек - чёрный
    Canvas.setColour(Colours::black);
    
    int iPointsNumber = 8; // Число точек
    // Вычисляем координаты точек
    for(int i = 0; i < iPointsNumber; ++i)
    {
        float fAngle = 2 * float_Pi * i / iPointsNumber;
        int iX = 50 + cos(fAngle) * 40;
        int iY = 50 + sin(fAngle) * 40;
        
        // Рисуем точку
        Canvas.setPixel(iX, iY);
    }
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
}
//---------------------------------------------------------------------

